﻿using System;
using System.Collections.Generic;
using System.Text;

using System.Net;

using System.Windows.Forms;

using System.Drawing;

namespace httpServer
{
    class Program
    {
        static void Main(string[] args)
        {
            int port = 9999;
            if(args.Length>0)
            {
                try
                {
                    port = int.Parse(args[0]);
                }
                catch
                {
                    port = 9999;
                }
            }
            HttpListener listener = new HttpListener();
            try
            {
                
                listener.Prefixes.Add("http://*:" + port + "/"); //添加需要监听的url范围
                listener.Start(); //开始监听端口，接收客户端请求
            }
            catch (Exception exp)
            {
                Console.WriteLine("error open listener:{0}", exp);
                //throw;
                return;
            }
            Console.WriteLine("Listening@port:{0} ...",port);
            Console.Title = string.Format("Listening@port:{0} ...", port);
            while (true)
            {
                //阻塞主函数至接收到一个客户端请求为止
                try
                {
                    HttpListenerContext context = listener.GetContext();
                    HttpListenerRequest request = context.Request;
                    Console.WriteLine("{0} {1}", DateTime.Now, request.RawUrl);
                    Console.Title = string.Format("{0} {1}", DateTime.Now, request.RawUrl);
                    if (request.Url.PathAndQuery.StartsWith("/close"))
                    {
                        break;
                    }
                    if (request.Url.PathAndQuery.StartsWith("/html"))
                    {
                        ShowHtml(context);
                        continue;
                    }
                    if (request.Url.PathAndQuery.StartsWith("/screen"))
                    {
                        GetScreen(context);
                        continue;
                    }
                    if (request.Url.PathAndQuery.StartsWith("/click"))
                    {
                        Click(context);
                        continue;
                    }
                    if (request.Url.PathAndQuery.StartsWith("/rclick"))
                    {
                        RClick(context);
                        continue;
                    }
                    if (request.Url.PathAndQuery.StartsWith("/key"))
                    {
                        Key(context);
                        continue;
                    }

                    ShowHtml(context);

                    //HttpListenerResponse response = context.Response;

                    //string responseString = string.Format("<HTML><BODY> {0}</BODY></HTML>", request.Url.PathAndQuery);
                    //byte[] buffer = System.Text.Encoding.UTF8.GetBytes(responseString);
                    ////对客户端输出相应信息.
                    //response.ContentLength64 = buffer.Length;
                    //System.IO.Stream output = response.OutputStream;
                    //output.Write(buffer, 0, buffer.Length);
                    ////关闭输出流，释放相应资源
                    //output.Close();
                }
                catch (Exception exp)
                {
                    Console.WriteLine("{0} {1}", DateTime.Now, exp);
                }
            }

            listener.Stop(); //关闭HttpListener
        }

        private static void ShowHtml(HttpListenerContext context)
        {
            WriteText(context, System.IO.File.ReadAllText("screen.htm"));
            Console.WriteLine("ShowHtml");
        }

        private static void RClick(HttpListenerContext context)
        {
            try
            {
                HttpListenerRequest request = context.Request;
                string[] param = request.Url.PathAndQuery.Split('/');
                int x = Convert.ToInt32(param[2]);
                int y = Convert.ToInt32(param[3]);



                script.pharaoh.com.Mouse.RClick(x, y);
                WriteText(context, x.ToString());
            }
            catch (Exception exp)
            {
                WriteText(context, "Get Image Error!");
                Console.WriteLine("Error in Click {0}", exp);
            }
        }

        private static void Key(HttpListenerContext context)
        {
            try
            {
                // /key/*
                HttpListenerRequest request = context.Request;
                string param = request.Url.PathAndQuery.Substring(5);

                param = UnEscape(param);


                SendKeys.SendWait(param);
                
                WriteText(context,param);
            }
            catch (Exception exp)
            {
                WriteText(context, "Key Error!");
                Console.WriteLine("Error in Click {0}", exp);
            }
        }

        private static string UnEscape(string str)
        {
            if (str == null)
                return String.Empty;

            StringBuilder sb = new StringBuilder();
            int len = str.Length;
            int i = 0;
            while (i != len)
            {
                if (Uri.IsHexEncoding(str, i))
                    sb.Append(Uri.HexUnescape(str, ref i));
                else
                    sb.Append(str[i++]);
            }

            return sb.ToString();
        }


        private static void Click(HttpListenerContext context)
        {
            try
            {
                HttpListenerRequest request = context.Request;
                string[] param = request.Url.PathAndQuery.Split('/');
                int x = Convert.ToInt32(param[2]);
                int y = Convert.ToInt32(param[3]);



                script.pharaoh.com.Mouse.Click(x, y);
                WriteText(context, x.ToString());
            }
            catch (Exception exp)
            {
                WriteText(context, "Get Image Error!");
                Console.WriteLine("Error in Click {0}", exp);
            }
        }

        private static void WriteText(HttpListenerContext context,string text)
        {
            HttpListenerResponse response = context.Response;
            response.ContentType = "text/html";
            string responseString = string.Format("<HTML><BODY> {0}</BODY></HTML>", text);
            byte[] buffer = System.Text.Encoding.UTF8.GetBytes(responseString);
            //对客户端输出相应信息.
            response.ContentLength64 = buffer.Length;
            System.IO.Stream output = response.OutputStream;
            output.Write(buffer, 0, buffer.Length);
            //关闭输出流，释放相应资源
            output.Close();
        }


        private static void GetScreen(HttpListenerContext context)
        {
            try
            {
                int width = Screen.PrimaryScreen.Bounds.Width;

                int height = Screen.PrimaryScreen.Bounds.Height;

                Bitmap bmp = new Bitmap(width, height);

                using (Graphics g = Graphics.FromImage(bmp))
                {

                    g.CopyFromScreen(0, 0, 0, 0, new Size(width, height));
                    //bmp.Save("c:\\screen.gif", System.Drawing.Imaging.ImageFormat.Gif);
                    HttpListenerResponse response = context.Response;
                    System.IO.MemoryStream stream = new System.IO.MemoryStream();
                    bmp.Save(stream, System.Drawing.Imaging.ImageFormat.Gif);
                    response.ContentLength64 = stream.Length;
                    response.ContentType = "image/gif";
                    response.OutputStream.Write(stream.GetBuffer(), 0, (int)stream.Length);
                    response.OutputStream.Close();
                    return;
                    //response.

                    //string responseString = string.Format("<HTML><BODY> saved</BODY></HTML>" );
                    //byte[] buffer = System.Text.Encoding.UTF8.GetBytes(responseString);
                    ////对客户端输出相应信息.
                    //response.ContentLength64 = buffer.Length;
                    //System.IO.Stream output = response.OutputStream;
                    //output.Write(buffer, 0, buffer.Length);
                    ////关闭输出流，释放相应资源
                    //output.Close();    

                }
            }
            catch (Exception exp)
            {
                Console.WriteLine("Error in GetScreen {0}", exp);
                WriteText(context, "Get Image Error!");
            }
        }
    }
}
